"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var common_vendor = require("../../../common/vendor.js");
const _sfc_main = {
  name: "lucky-wheel",
  data() {
    return {
      imgSrc: "",
      myLucky: null,
      canvas: null,
      isShow: false,
      boxWidth: 100,
      boxHeight: 100,
      btnWidth: 0,
      btnHeight: 0,
      dpr: 1
    };
  },
  props: {
    width: {
      type: String,
      default: "600rpx"
    },
    height: {
      type: String,
      default: "600rpx"
    },
    blocks: {
      type: Array,
      default: () => []
    },
    prizes: {
      type: Array,
      default: () => []
    },
    buttons: {
      type: Array,
      default: () => []
    },
    defaultConfig: {
      type: Object,
      default: () => ({})
    },
    defaultStyle: {
      type: Object,
      default: () => ({})
    }
  },
  mounted() {
    this.initLucky();
  },
  watch: {
    blocks(newData) {
      this.myLucky && (this.myLucky.blocks = newData);
    },
    prizes(newData) {
      this.myLucky && (this.myLucky.prizes = newData);
    },
    buttons(newData) {
      this.myLucky && (this.myLucky.buttons = newData);
    },
    defaultStyle(newData) {
      this.myLucky && (this.myLucky.defaultStyle = newData);
    },
    defaultConfig(newData) {
      this.myLucky && (this.myLucky.defaultConfig = newData);
    }
  },
  methods: {
    async imgBindload(res, name, index, i) {
      const img = this[name][index].imgs[i];
      common_vendor.resolveImage(img, this.canvas);
    },
    getImage() {
      return common_vendor.getImage.call(this, "lucky-wheel", this.canvas);
    },
    hideCanvas() {
      this.getImage().then((res) => {
        this.imgSrc = res.tempFilePath;
      });
    },
    initLucky() {
      this.boxWidth = common_vendor.changeUnits(this.width);
      this.boxHeight = common_vendor.changeUnits(this.height);
      this.isShow = true;
      this.$nextTick(() => {
        setTimeout(() => {
          this.draw();
        });
      });
    },
    draw() {
      const _this = this;
      common_vendor.index.createSelectorQuery().in(this).select("#lucky-wheel").fields({
        node: true,
        size: true
      }).exec((res) => {
        if (!res[0] || !res[0].node)
          return console.error("lucky-canvas \u83B7\u53D6\u4E0D\u5230 canvas \u6807\u7B7E");
        const { node, width, height } = res[0];
        const canvas = this.canvas = node;
        const ctx = this.ctx = canvas.getContext("2d");
        const dpr = this.dpr = common_vendor.index.getSystemInfoSync().pixelRatio;
        canvas.width = width * dpr;
        canvas.height = height * dpr;
        ctx.scale(dpr, dpr);
        const Radius = Math.min(width, height) / 2;
        this.myLucky = new common_vendor.T({
          flag: "MP-WX",
          ctx,
          dpr,
          setTimeout,
          clearTimeout,
          setInterval,
          clearInterval,
          unitFunc: (num, unit) => common_vendor.changeUnits(num + unit),
          beforeCreate: function() {
            ctx.translate(Radius, Radius);
          },
          beforeResize: function() {
            ctx.translate(-Radius, -Radius);
          },
          afterInit: function() {
            _this.btnWidth = this.maxBtnRadius * 2;
            _this.btnHeight = this.maxBtnRadius * 2;
            _this.$forceUpdate();
          },
          afterStart: () => {
            this.imgSrc = "";
          }
        }, __spreadProps(__spreadValues({}, this.$props), {
          width,
          height,
          start: (...rest) => {
            this.$emit("start", ...rest);
          },
          end: (...rest) => {
            this.$emit("end", ...rest);
            this.hideCanvas();
          }
        }));
      });
    },
    toPlay(e) {
      this.myLucky.startCallback();
    },
    init() {
      this.myLucky.init();
    },
    play(...rest) {
      this.myLucky.play(...rest);
    },
    stop(...rest) {
      this.myLucky.stop(...rest);
    }
  }
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return common_vendor.e({
    a: $data.isShow
  }, $data.isShow ? common_vendor.e({
    b: $data.boxWidth + "px",
    c: $data.boxHeight + "px",
    d: $data.imgSrc
  }, $data.imgSrc ? {
    e: $data.imgSrc,
    f: common_vendor.o(($event) => $data.myLucky.clearCanvas()),
    g: $data.boxWidth + "px",
    h: $data.boxHeight + "px"
  } : {}, {
    i: common_vendor.o((...args) => $options.toPlay && $options.toPlay(...args)),
    j: $data.btnWidth + "px",
    k: $data.btnHeight + "px",
    l: $data.myLucky
  }, $data.myLucky ? {
    m: common_vendor.f($props.blocks, (block, index, i0) => {
      return common_vendor.e({
        a: block.imgs
      }, block.imgs ? {
        b: common_vendor.f(block.imgs, (img, i, i1) => {
          return {
            a: i,
            b: img.src,
            c: common_vendor.o((e) => $options.imgBindload(e, "blocks", index, i))
          };
        })
      } : {}, {
        c: index
      });
    }),
    n: common_vendor.f($props.prizes, (prize, index, i0) => {
      return common_vendor.e({
        a: prize.imgs
      }, prize.imgs ? {
        b: common_vendor.f(prize.imgs, (img, i, i1) => {
          return {
            a: i,
            b: img.src,
            c: common_vendor.o((e) => $options.imgBindload(e, "prizes", index, i))
          };
        })
      } : {}, {
        c: index
      });
    }),
    o: common_vendor.f($props.buttons, (btn, index, i0) => {
      return common_vendor.e({
        a: btn.imgs
      }, btn.imgs ? {
        b: common_vendor.f(btn.imgs, (img, i, i1) => {
          return {
            a: i,
            b: img.src,
            c: common_vendor.o((e) => $options.imgBindload(e, "buttons", index, i))
          };
        })
      } : {}, {
        c: index
      });
    })
  } : {}, {
    p: $data.boxWidth + "px",
    q: $data.boxHeight + "px"
  }) : {});
}
var Component = /* @__PURE__ */ common_vendor._export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-a0d692a4"], ["__file", "D:/project/uniapp/test/node_modules/@lucky-canvas/uni/lucky-wheel.vue"]]);
wx.createComponent(Component);
